//+------------------------------------------------------------------+
//|                                                 RSI-AREA.mq4     |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
 
extern int RSIPeriod=13;
extern int AreaCondition=300;
double RSIArea,RSIOpen;
int init() {return(0);}
int deinit() {return(0);}
double RSIAreaFunc(int& RSIAreaShift, double RSIPeriod, int BeginShift)
 {
  int shift;
  double rsivalue, result; 
  result = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, BeginShift) - 50.0;
  for(shift=BeginShift+1; shift<Bars-RSIAreaShift; shift++)
   {
    rsivalue = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, shift) - 50.0;
    if((result>0 && rsivalue<-3) || (result<0 && rsivalue>3))
     {
      RSIAreaShift=shift;
      break;
     }
    result += rsivalue;
   }
  return(result);
 }
// 
int start()
 {
  static int RSIAreaShift=0;
  int cnt, shift;
  double RSICurrent, RSILocalMin, RSILocalMax, value;
//--
  if(OrdersTotal()<1)
   {
    RSIArea = RSIAreaFunc(RSIAreaShift, RSIPeriod, 0);
    if(RSIArea<-AreaCondition)
     {
      OrderSend(Symbol(),OP_BUY,1.0,Ask,3,0.0,0.0);
      RSIOpen = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, 0);
      return(0);
     }
    if(RSIArea>AreaCondition)
     {
      OrderSend(Symbol(),OP_SELL,1.0,Bid,3,0.0,0.0);
      RSIOpen = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, 0);
      return(0);
     }    
   }
  RSICurrent = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, 0);
  if(RSIOpen>50 && RSICurrent>50) return(0);
  if(RSIOpen<50 && RSICurrent<50) return(0);      
  RSILocalMin = RSICurrent;
  RSILocalMax = RSICurrent;
  for(shift=1; shift<RSIAreaShift; shift++)
   {
    value = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, shift);
    if(value<RSILocalMin && RSIArea>0) RSILocalMin=value;
    if(value>RSILocalMax && RSIArea<0) RSILocalMax=value;   
    for(cnt=OrdersTotal()-1; cnt>=0; cnt--)
     {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
       {
        if(OrderType()==OP_BUY)
         {
          if(RSILocalMax>=RSICurrent+4 && RSILocalMax>50)OrderClose(OrderTicket(),OrderLots(),Bid,3);
         }
        if(OrderType()==OP_SELL)
         {
          if(RSILocalMin<=RSICurrent-4 && RSILocalMin<50)OrderClose(OrderTicket(),OrderLots(),Ask,3);
         }
       }
     }
   }    
  return(0);
 }